> For the complete documentation index, see [llms.txt](https://docs.polyfrost.org/oneconfig/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.polyfrost.org/oneconfig/utils/oneuiscreen.md).

# OneUIScreen

OneConfig's easy to use, multiplatform GuiScreen alternative

## Why?

OneUIScreen is a convenient class that can be used for easy handling of mouse, keyboard, and rendering with NanoVG (see [Broken mention](broken://pages/N2Gvbih0Phu7KFxrJKpc)).

## Creating a OneUIScreen

Creating a OneUIScreen is simple - just extend the class, like so:

```java
public class MyScreen extends OneUIScreen {
    public MyScreen() {
        super();        // constructor for your screen - you can initialize things here as well
    }

    @Override
    public void initScreen(int width, int height) {
        super.initScreen(width, height);
        // setup variables, initialize components, etc.
    }       

    @Override
    public void draw(long vg, float partialTicks) {
        // draw script for the screen with a NanoVG context already prepared
        RenderManager.drawRoundedRect(10,50,100,100,-1,12f);
        // You can also use partialTicks for animations as a deltaTime.

    @Override
    public void onScreenClose() {
        // clean up, etc. when the screen closes.
    }
```

## Displaying Your Screen

You can Display your screen in many ways, for example using a [Buttons, Colors and Keybinds](/oneconfig/config/adding-options/buttons-colors-and-keybinds.md#button) implementation, or opening it when a key is pressed using a OneKeyBind. They can be opened easily using `GuiUtils.displayScreen(new MyScreen())`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.polyfrost.org/oneconfig/utils/oneuiscreen.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
